Package com.sas.metadata.remote

# Interface SecuredLibrary

All Superinterfaces:
  `CMetadata`, `DeployedDataPackage`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `RelationalSchema`, `Remote`, `Root`, `SASLibrary`

public interface SecuredLibrary extends SASLibrary
A SecuredLibrary object is created for a SAS physical library when it is bound to metadata with the AUTHLIB procedure of SAS. The location of the securedLibrary object is stored in the physical library such that the SAS system will not access the physical library without first establishing an authenticated identity and connection to the metadata server and obtaining the identity's data permissions for this object. These data permissions then determine what actions the SAS system will allow that identity to perform on the physical data. SecuredLibrary objects should not be created or manipulated by any code other than the AUTHLIB procedure as they will not be or will no longer be effective. The physical data will not be accessible if an existing SecuredLibrary object is modified by other means.

Attributes of SecuredLibrary are:

- `Encrypt`

Associations of SecuredLibrary are:

- `DefaultPasswords`

## Usage

To create an instance of this SecuredLibrary, use the `factory` create methods.
Example: create a SecuredLibrary with name "SecuredLibrary_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     SecuredLibrary myObject = (SecuredLibrary) factory.createComplexMetadataObject(objectStore, "SecuredLibrary_Object", MetadataObjects.SECUREDLIBRARY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_DEFAULTPASSWORDS_NAME`
  Constant used for the name of the DefaultPasswords association.
  `static final String`
  `ATTRIBUTE_ENCRYPT_NAME`
  Constant used for the name of the Encrypt attribute.

  ### Fields inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `ASSOCIATION_ALIASES_NAME, ASSOCIATION_ALIASFOR_NAME, ASSOCIATION_DEPLOYEDCOMPONENTS_NAME, ASSOCIATION_TABLECOLLECTIONS_NAME, ASSOCIATION_USEDBYPACKAGES_NAME, ASSOCIATION_USINGPACKAGES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.RelationalSchema

  `ASSOCIATION_SCHEMAPACKAGE_NAME, ASSOCIATION_TABLES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.SASLibrary

  `ASSOCIATION_DEFAULTLOGIN_NAME, ASSOCIATION_LIBRARYCONNECTION_NAME, ASSOCIATION_SASCATALOGS_NAME, ATTRIBUTE_ENGINE_NAME, ATTRIBUTE_ISDBMSLIBNAME_NAME, ATTRIBUTE_ISPREASSIGNED_NAME, ATTRIBUTE_LIBREF_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getDefaultPasswords()`
  Gets the Association list of `DefaultPasswords`
  `AssociationList`
  `getDefaultPasswords(boolean fGoToServer)`
  Gets the Associationlist of `DefaultPasswords`
  `String`
  `getEncrypt()`
  Gets the `String` value of `Encrypt`
  `int`
  `getEncryptMaxLength()`
  Gets the maximum length of `Encrypt`
  `int`
  `getEncryptState()`
  Gets the Metadata State of `Encrypt`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setDefaultPasswords(AssociationList list)`
  Sets the `DefaultPasswords` list to be `list`.
  `void`
  `setDefaultPasswords(AssociationList inObjects, int state)`
  Sets the entire DefaultPasswords list to match the passed in AssociationList, sets the state of the DefaultPasswords
  `void`
  `setEncrypt(String inEncrypt)`
  Sets the `Encrypt` value and sets the state to MetadataState.LOCAL.
  `void`
  `setEncrypt(String inEncrypt, int state)`
  Sets the `Encrypt` Metadata State.
  `void`
  `setEncryptState(int state)`
  Sets the Metadata State of `Encrypt`.

  ### Methods inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `getAliases, getAliases, getAliasFor, getAliasFors, getAliasFors, getDeployedComponents, getDeployedComponents, getTableCollections, getTableCollections, getUsedByPackages, getUsedByPackages, getUsingPackages, getUsingPackages, setAliases, setAliases, setAliasFor, setAliasFors, setAliasFors, setDeployedComponents, setDeployedComponents, setTableCollections, setTableCollections, setUsedByPackages, setUsedByPackages, setUsingPackages, setUsingPackages`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.RelationalSchema

  `getSchemaPackage, getSchemaPackages, getSchemaPackages, getTables, getTables, setSchemaPackage, setSchemaPackages, setSchemaPackages, setTables, setTables`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

  ### Methods inherited from interface com.sas.metadata.remote.SASLibrary

  `getDefaultLogin, getDefaultLogins, getDefaultLogins, getEngine, getEngineMaxLength, getEngineState, getIsDBMSLibname, getIsDBMSLibnameState, getIsPreassigned, getIsPreassignedState, getLibraryConnection, getLibraryConnections, getLibraryConnections, getLibref, getLibrefMaxLength, getLibrefState, getSASCatalogs, getSASCatalogs, setDefaultLogin, setDefaultLogins, setDefaultLogins, setEngine, setEngine, setEngineState, setIsDBMSLibname, setIsDBMSLibname, setIsDBMSLibname, setIsDBMSLibname, setIsDBMSLibnameState, setIsPreassigned, setIsPreassigned, setIsPreassigned, setIsPreassigned, setIsPreassignedState, setLibraryConnection, setLibraryConnections, setLibraryConnections, setLibref, setLibref, setLibrefState, setSASCatalogs, setSASCatalogs`

- ## Field Details

  - ### ATTRIBUTE_ENCRYPT_NAME

    static final String ATTRIBUTE_ENCRYPT_NAME
    Constant used for the name of the Encrypt attribute.

    Encrypt: The encrypt value for this secured library. Valid values are Y (Yes), N (No), or R (Required).

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DEFAULTPASSWORDS_NAME

    static final String ASSOCIATION_DEFAULTPASSWORDS_NAME
    Constant used for the name of the DefaultPasswords association.

    DefaultPasswords: The default passwords used by this secured library.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `RelationalSchema`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SASLibrary`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `RelationalSchema`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SASLibrary`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEncrypt

    String getEncrypt() throws RemoteException
    Gets the `String` value of `Encrypt`
    Returns:
      The `Encrypt`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEncryptState

    int getEncryptState() throws RemoteException
    Gets the Metadata State of `Encrypt`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEncryptMaxLength

    int getEncryptMaxLength() throws RemoteException
    Gets the maximum length of `Encrypt`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultPasswords

    AssociationList getDefaultPasswords() throws RemoteException, MdException
    Gets the Association list of `DefaultPasswords`
    Returns:
      The AssociationList of `DefaultPasswords` which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDefaultPasswords

    AssociationList getDefaultPasswords(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `DefaultPasswords`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `DefaultPasswords` which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setEncrypt

    void setEncrypt(String inEncrypt) throws RemoteException
    Sets the `Encrypt` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inEncrypt` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEncrypt

    void setEncrypt(String inEncrypt, int state) throws RemoteException
    Sets the `Encrypt` Metadata State.
    Parameters:
      `inEncrypt` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEncryptState

    void setEncryptState(int state) throws RemoteException
    Sets the Metadata State of `Encrypt`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultPasswords

    void setDefaultPasswords(AssociationList list) throws RemoteException
    Sets the `DefaultPasswords` list to be `list`. Objects of which can be of type:
    SASPassword
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultPasswords

    void setDefaultPasswords(AssociationList inObjects, int state) throws RemoteException
    Sets the entire DefaultPasswords list to match the passed in AssociationList, sets the state of the DefaultPasswords
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.